import Model

extension Player: CustomStringConvertible {
    public var description: String {
        switch self {
        case .A:
            "🔴"
        case .B:
            "🟡"
        }
    }
}

extension Board: CustomStringConvertible, CustomDebugStringConvertible {
    public var description: String {
        var str = String()
        
        for row in 0..<self.rows {
            for col in 0..<self.columns {
                str += self[col, row]?.owner.description ?? "⚪"
            }
            
            str += "\n"
        }
        
        return str
    }
    
    public var debugDescription: String {
        return "Board[\(self.columns)x\(self.rows), \(self.countPieces { p in p.owner == .A }) A and \(self.countPieces { p in p.owner == .B }) B pieces]"
    }
}


